pub fn task_one(input: &str) -> String {
    let mut counter: usize = 0;

    let mut last_line: String = String::new();

    for line in input.lines() {
        if last_line.is_empty() {
            last_line = line.to_string();
            continue
        } else {
            if last_line.parse::<usize>().unwrap() < line.parse::<usize>().unwrap() {
                counter = counter + 1;
            }

            last_line = line.to_string();
        }
    }

    return counter.to_string();
}

pub fn task_two(input: &str) -> String {
    let mut counter: usize = 0;

    let mut top_line: String = String::new();
    let mut middle_line: String = String::new();
    let mut last_line: String = String::new();

    let mut current_frame: usize;
    let mut last_frame: usize = 0;

    for (i, line) in input.lines().enumerate() {
        match i {
            0 => top_line = line.to_string(),
            1 => middle_line = line.to_string(),
            2 => last_line = line.to_string(),
            _ => {
                current_frame = top_line.parse::<usize>().unwrap() + middle_line.parse::<usize>().unwrap() + last_line.parse::<usize>().unwrap();

                if  last_frame != 0 && last_frame < current_frame {
                    counter = counter + 1;
                }
                
                last_frame = current_frame;

                top_line = middle_line;
                middle_line = last_line;
                last_line = line.to_string();
            },
        }
        // println!("{}\t\t {}\t{}\t{}\t current_frame: {}", i, top_line, middle_line, last_line, current_frame);
    }

    current_frame = top_line.parse::<usize>().unwrap() + middle_line.parse::<usize>().unwrap() + last_line.parse::<usize>().unwrap();
    if last_frame < current_frame {
        counter = counter + 1;
    }

    return counter.to_string();
}
