pub fn task_one(input: &str) -> String {
    let mut horizontal_pos: usize = 0;
    let mut depth: usize = 0;

    for line in input.lines() {
        let split = line.split_once(' ').unwrap();
        let amount = split.1.trim().parse::<usize>().unwrap();

        match split.0 {
            "forward" => horizontal_pos = horizontal_pos + amount,
            "down" => depth = depth + amount,
            "up" => depth = depth - amount,
            _ => panic!()
        }
    }

    return (horizontal_pos * depth).to_string();
}

pub fn task_two(input: &str) -> String {
    let mut horizontal_pos: usize = 0;
    let mut depth: usize = 0;
    let mut aim: usize = 0;

    for line in input.lines() {
        let split = line.split_once(' ').unwrap();
        let amount = split.1.trim().parse::<usize>().unwrap();

        match split.0 {
            "forward" => {
                horizontal_pos = horizontal_pos + amount;
                depth = depth + aim * amount;
            },
            "down" => aim = aim + amount,
            "up" => aim = aim - amount,
            _ => panic!()
        }
    }

    return (horizontal_pos * depth).to_string();
}
