fn get_calories(input: &str) -> Vec<usize> {
    let mut calories: Vec<usize> = Vec::new();

    let mut sum = 0_usize;

    for line in input.lines() {
        match line.parse::<usize>() {
            Ok(calorie) => sum += calorie,
            Err(_) => {
                calories.push(sum);
                sum = 0;
            }
        }
    }

    calories.sort();
    calories
}

pub fn task_one(input: &str) -> String {
    let calories = get_calories(input);

    calories.last().unwrap().to_string()
}

pub fn task_two(input: &str) -> String {
    let calories = get_calories(input);

    let count = calories.len();

    let slice = calories.get(count - 3 ..).unwrap();
    slice.into_iter().sum::<usize>().to_string()
}
