fn calc_sum(chars: &Vec<char>) -> u32 {
    let mut sum = 0;

    for c in chars {
        if c.is_ascii_lowercase() {
            sum += *c as u32 - 96;
        } else {
            sum += *c as u32 - 38;
        }
    }

    sum
}

pub fn task_one(input: &str) -> String {
    let mut double_chars = Vec::new();

    for line in input.lines() {
        let amount_of_chars = line.chars().count();
        let (first_half, last_half) = line.split_at(amount_of_chars / 2);

        let mut char_in_both: Option<char> = None;

        for c in first_half.chars() {
            if last_half.contains(c) {
                char_in_both = Some(c);
            }
        }

        for c in last_half.chars() {
            if first_half.contains(c) {
                char_in_both = Some(c);
            }
        }

        if char_in_both.is_some() {
            double_chars.push(char_in_both.unwrap());
        }
    }

    calc_sum(&double_chars).to_string()
}

pub fn task_two(input: &str) -> String {
    let mut interesing_chars: Vec<char> = Vec::new();

    let lines: Vec<&str> = input.lines().collect::<Vec<&str>>();
    let mut iterator = lines.windows(3);

    loop {
        if let Some([first, second, third]) = iterator.next() {
            let mut all_possible_chars: Vec<char> = first.chars().collect();
            all_possible_chars.append(&mut second.chars().collect::<Vec<char>>());
            all_possible_chars.append(&mut third.chars().collect::<Vec<char>>());

            for c in all_possible_chars {
                if first.contains(c) && second.contains(c) && third.contains(c) {
                    interesing_chars.push(c);
                    break;
                }
            }

            iterator.next();
            iterator.next();
        } else {
            break;
        }
    }

    calc_sum(&interesing_chars).to_string()
}
